/*
 *  Routines for Gravis UltraSound soundcards - Synthesizer
 *  Copyright (c) by Jaroslav Kysela <perex@suse.cz>
 *
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include "driver.h"
#include "gus.h"

/*
 *
 */

static int snd_gus_synth_use(void *private_data)
{
	snd_gus_card_t * gus = (snd_gus_card_t *)private_data;

	snd_mutex_down(gus, register);
	snd_gus_use_inc(gus);
	snd_mutex_up(gus, register);
	return 0;
}

static int snd_gus_synth_unuse(void *private_data)
{
	snd_gus_card_t * gus = (snd_gus_card_t *)private_data;

	snd_mutex_down(gus, register);
	snd_gus_use_dec(gus);
	snd_mutex_up(gus, register);
	return 0;
}

/*
 *
 */
 
int snd_gus_synth_event_input(snd_seq_event_t *ev, int direct, void *private_data)
{
	snd_gus_port_t * p = (snd_gus_port_t *) private_data;
	
	if (p == NULL)
		return -EINVAL;
	if (direct) {
		if (ev->type >= SND_SEQ_EVENT_INSTR_BEGIN) {
			snd_seq_instr_event(&p->gus->gf1.iwffff_ops.kops,
					    p->gus->gf1.ilist,
					    ev,
					    0);
			return 0;
		}
	}
		
	return 0;
}

/*
 *
 */

static void snd_gus_synth_free_port(void *private_data)
{
	snd_gus_port_t * p = (snd_gus_port_t *)private_data;
	
	if (p)
		snd_midi_channel_free_set(p->chset);
}

static int snd_gus_synth_create_port(snd_gus_card_t * gus, int idx)
{
	snd_gus_port_t * p;
	snd_seq_port_callback_t callbacks;
	char name[32];
	int result;
	
	p = &gus->gf1.seq_ports[idx];
	p->chset = snd_midi_channel_alloc_set(16);
	if (p->chset == NULL)
		return -ENOMEM;
	p->chset->private_data = p;
	p->gus = gus;
	p->client = gus->gf1.seq_client;

	memset(&callbacks, 0, sizeof(callbacks));
	callbacks.use = snd_gus_synth_use;
	callbacks.unuse = snd_gus_synth_unuse;
	callbacks.event_input = snd_gus_synth_event_input;
	callbacks.private_free = snd_gus_synth_free_port;
	callbacks.private_data = p;
	
	sprintf(name, "%s port %i", gus->interwave ? "AMD InterWave" : "GF1", idx);
	p->chset->port = snd_seq_event_port_attach(gus->gf1.seq_client,
						   &callbacks,
						   SND_SEQ_PORT_CAP_OUT,
						   SND_SEQ_PORT_TYPE_MIDI_GENERIC |
						   SND_SEQ_PORT_TYPE_MIDI_GM |
						   SND_SEQ_PORT_TYPE_MIDI_GS |
						   SND_SEQ_PORT_TYPE_DIRECT_SAMPLE |
						   SND_SEQ_PORT_TYPE_SYNTH,
						   name);
	if (p->chset->port < 0) {
		result = p->chset->port;
		snd_gus_synth_free_port(p);
		return result;
	}
	return 0;
}						 

/*
 *
 */

int snd_gus_attach_synthesizer(snd_gus_card_t * gus)
{
	int client, i;
	snd_seq_client_callback_t callbacks;
	snd_seq_client_info_t cinfo;
	snd_iwffff_ops_t *iwops;

	snd_mutex_prepare(gus, register);
	
	/* allocate new client */
	memset(&callbacks, 0, sizeof(callbacks));
	callbacks.private_data = gus;
	callbacks.allow_output = callbacks.allow_input = 1;
	client = gus->gf1.seq_client =
			snd_seq_create_kernel_client(gus->card, 1, &callbacks);
	if (client < 0)
		return client;

	/* change name of client */
	memset(&cinfo, 0, sizeof(cinfo));
	cinfo.client = client;
	cinfo.type = KERNEL_CLIENT;
	sprintf(cinfo.name, gus->interwave ? "AMD InterWave" : "GF1");
	snd_seq_kernel_client_ctl(client, SND_SEQ_IOCTL_SET_CLIENT_INFO, &cinfo);

	for (i = 0; i < 4; i++)
		snd_gus_synth_create_port(gus, i);

	gus->gf1.ilist = snd_seq_instr_list_new();
	if (gus->gf1.ilist == NULL) {
		snd_gus_detach_synthesizer(gus);
		return -ENOMEM;
	}
	iwops = &gus->gf1.iwffff_ops;
	snd_seq_iwffff_init(iwops, gus, SND_SEQ_INSTR_OPS_DIRECT, NULL);
	iwops->put_sample = snd_gus_iwffff_put_sample;
	iwops->get_sample = snd_gus_iwffff_get_sample;
	iwops->remove_sample = snd_gus_iwffff_remove_sample;

	return 0;
}

int snd_gus_detach_synthesizer(snd_gus_card_t * gus)
{
	if (gus->gf1.seq_client >= 0)
		snd_seq_delete_kernel_client(gus->gf1.seq_client);	
	return 0;
}
